package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.AttributeModifierFindable;
import de.fhdw.wtf.common.ast.AttributeModifierMutable;
import de.fhdw.wtf.common.ast.AttributeModifierPrior;
import de.fhdw.wtf.common.ast.AttributeModifierSymmetric;
import de.fhdw.wtf.common.ast.AttributeModifierTransient;

/**
 * ReturnException-Visitor of {@link de.fhdw.wtf.common.ast.AttributeModifier}.
 * 
 * @param <X>
 *            Return-type.
 * @param <Y>
 *            Exception Type
 */
public interface AttributeModifierVisitorReturnException<X, Y extends Exception> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param modFindable
	 *            {@link AttributeModifierFindable}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(AttributeModifierFindable modFindable) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param modPrior
	 *            {@link AttributeModifierPrior}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(AttributeModifierPrior modPrior) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param modTransient
	 *            {@link AttributeModifierTransient}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(AttributeModifierTransient modTransient) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param modMutable
	 *            {@link AttributeModifierMutable}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(AttributeModifierMutable modMutable) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param modSymmetric
	 *            {@link AttributeModifierSymmetric}
	 * @return X
	 * @throws Y
	 *             Y
	 */
	X handle(AttributeModifierSymmetric modSymmetric) throws Y;
}
