package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.ExceptionClassType;
import de.fhdw.wtf.common.ast.type.RegularClassType;

/**
 * Exception-Visitor for {@link de.fhdw.wtf.common.ast.type.ClassType }
 *
 * @param <Y>
 *            Exception to be thrown
 */
public interface ClassTypeVisitorException<Y extends Exception> {
	/**
	 * Handle-Method.
	 * 
	 * @param regularClassType
	 *            {@link RegularClassType}
	 * @throws Y
	 *             Exception to be thrown
	 */
	void handle(RegularClassType regularClassType) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param exceptionClassType
	 *            {@link ExceptionClassType}
	 * @throws Y
	 *             Exception to be thrown
	 */
	void handle(ExceptionClassType exceptionClassType) throws Y;
}
