package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.ExceptionClassType;
import de.fhdw.wtf.common.ast.type.RegularClassType;

/**
 * Return-Exception-Visitor for {@link de.fhdw.wtf.common.ast.type.ClassType}
 *
 * @param <X>
 *            Return type
 * @param <Y>
 *            Exception to be thrown
 */
public interface ClassTypeVisitorReturnException<X, Y extends Exception> {
	/**
	 * Handle-Method.
	 * 
	 * @param regularClassType
	 *            {@link RegularClassType}
	 * @return Return of type given by generics
	 * @throws Y
	 *             Exception to be thrown of type given by generics
	 */
	X handle(RegularClassType regularClassType) throws Y;
	
	/**
	 * Handle-Method.
	 * 
	 * @param exceptionClassType
	 *            {@link ExceptionClassType}
	 * @return Return of type given by generics
	 * @throws Y
	 *             Exception to be thrown of type given by generics
	 */
	X handle(ExceptionClassType exceptionClassType) throws Y;
}
