package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.ByNameState;
import de.fhdw.wtf.common.ast.type.ByReferenceState;
import de.fhdw.wtf.common.ast.type.InvalidState;

/**
 * Return Visitor for {@link de.fhdw.wtf.common.ast.type.TypeProxyState}.
 * 
 * @param <X>
 *            ReturnType.
 */
public interface TypeProxyStateVisitorReturn<X> {
	
	/**
	 * Handle operations for the type {@link ByNameState}.
	 * 
	 * @param byName
	 *            {@link ByNameState}
	 * @return X
	 */
	X handle(ByNameState byName);
	
	/**
	 * Handle operations for the type {@link InvalidState}.
	 * 
	 * @param invalid
	 *            {@link InvalidState}
	 * @return X
	 */
	X handle(InvalidState invalid);
	
	/**
	 * Handle operations for the type {@link ByReferenceState}.
	 * 
	 * @param byReference
	 *            {@link ByReferenceState}
	 * @return X
	 */
	X handle(ByReferenceState byReference);
	
}
