package de.fhdw.wtf.common.constants.parser;

/**
 * Contains constants for wtf-symbols.
 */
public final class AstDescriptionConstants {
	
	/**
	 * Keyword "abstract".
	 */
	public static final String MODIFIER_ABSTRACT = "abstract";
	
	/**
	 * Symbol ">".
	 */
	public static final String GREATER_SYMBOL = ">";
	
	/**
	 * Symbol ":".
	 */
	public static final String COLON_TOKEN = ":";
	
	/**
	 * Symbol ";".
	 */
	public static final String SEMICOLON_TOKEN = ";";
	
	/**
	 * Prefix for {@link de.fhdw.wtf.common.ast.Model#toString()}.
	 */
	public static final String MODEL_TO_STRING = "Model:";
	
	/**
	 * Keyword "group".
	 */
	public static final String GROUP_TOKEN = "group";
	
	/**
	 * Symbol "=".
	 */
	public static final String EQUAL_TOKEN = "=";
	
	/**
	 * Symbol "[".
	 */
	public static final String SQUARE_BRACKET_OPEN = "[";
	
	/**
	 * Symbol "]".
	 */
	public static final String SQUARE_BRACKET_CLOSE = "]";
	
	/**
	 * Keyword "class".
	 */
	public static final String CLASS_TOKEN = "class";
	
	/**
	 * Keyword "exception".
	 */
	public static final String EXCEPTION_TOKEN = "exception";
	
	/**
	 * Symbol "+".
	 */
	public static final String PLUS_TOKEN = " + ";
	
	/**
	 * Symbol "{".
	 */
	public static final String CURLY_BRACKET_OPEN_TOKEN = "{";
	
	/**
	 * Symbol "}".
	 */
	public static final String CURLY_BRACKET_CLOSE_TOKEN = "}";
	
	/**
	 * Symbol "(".
	 */
	public static final String BRACKET_OPEN_TOKEN = "(";
	
	/**
	 * Symbol ")".
	 */
	public static final String BRACKET_CLOSE_TOKEN = ")";
	
	/**
	 * Symbol "-".
	 */
	public static final String HYPHEN_TOKEN = "-";
	
	/**
	 * Keyword "prior".
	 */
	public static final String MODIFIER_PRIOR = "prior";
	
	/**
	 * Keyword "transient".
	 */
	public static final String MODIFIER_TRANSIENT = "transient";
	
	/**
	 * Keyword "findable".
	 */
	public static final String MODIFIER_FINDABLE = "findable";
	
	/**
	 * Keyword "mutable".
	 */
	public static final String MODIFIER_MUTABLE = "mutable";
	
	/**
	 * Keyword "visitable".
	 */
	public static final String MODIFIER_VISITABLE = "visitable";
	
	/**
	 * Keyword "service".
	 */
	public static final String MODIFIER_SERVICE = "service";
	
	/**
	 * Symbol "*".
	 */
	public static final String ASTERISK_TOKEN = "*";
	
	/**
	 * Symbol "[[".
	 */
	public static final String DOUBLE_SQUARE_BRACKET_OPEN_TOKEN = "[[";
	
	/**
	 * Symbol "]]".
	 */
	public static final String DOUBLE_SQUARE_BRACKET_CLOSE_TOKEN = "]]";
	
	/**
	 * Symbol "->".
	 */
	public static final String ARROW_TOKEN = "->";
	
	/**
	 * Symbol ",".
	 */
	public static final Object COMMA_TOKEN = ",";
	
	/**
	 * Contains constants for wtf-symbols.
	 */
	private AstDescriptionConstants() {
	}
	
}
