package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.constants.parser.ExceptionConstants;
import de.fhdw.wtf.common.token.Token;

/**
 * {@link ClassModifierAlreadyAddedException} will be thrown, if an {@link de.fhdw.wtf.common.ast.type.ClassModifier}
 * add to the list of modifiers and the modifier already exists in the list.
 * 
 */
public class ClassModifierAlreadyAddedException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -368967500775319409L;
	
	/**
	 * Constructor of {@link ClassModifierAlreadyAddedException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	protected ClassModifierAlreadyAddedException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link ClassModifierAlreadyAddedException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link ClassModifierAlreadyAddedException}-Object.
	 */
	public static ClassModifierAlreadyAddedException create(final Token token) {
		return new ClassModifierAlreadyAddedException(token, ExceptionConstants.CLASS_MODIFIER_ALREADY_ADDED_EXCEPTION);
	}
}
