package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoEqualException} will be thrown if a {@link de.fhdw.wtf.common.token.symbols.EqualToken} is expected, but
 * an another Token was found.
 * 
 */
public final class NoEqualException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -4100320072922309101L;
	
	/**
	 * Constructor of {@link NoEqualException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoEqualException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoEqualException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoEqualException}-Object.
	 */
	public static NoEqualException create(final Token token) {
		return new NoEqualException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_EQUAL_EXCEPTION_MESSAGE);
	}
}
