package de.fhdw.wtf.walker.tasks;

import java.util.HashMap;
import java.util.Set;

import de.fhdw.wtf.common.ast.Attribute;
import de.fhdw.wtf.common.ast.Constructor;
import de.fhdw.wtf.common.ast.ConstructorOrOperation;
import de.fhdw.wtf.common.ast.Group;
import de.fhdw.wtf.common.ast.Model;
import de.fhdw.wtf.common.ast.Operation;
import de.fhdw.wtf.common.ast.type.AtomicType;
import de.fhdw.wtf.common.ast.type.ClassType;
import de.fhdw.wtf.common.ast.type.CompositeType;
import de.fhdw.wtf.common.ast.type.ThrownType;
import de.fhdw.wtf.common.ast.type.Type;
import de.fhdw.wtf.common.ast.type.TypeProxy;
import de.fhdw.wtf.common.ast.visitor.ConstructorOrOperationExceptionVisitor;
import de.fhdw.wtf.common.ast.visitor.TypeVisitor;
import de.fhdw.wtf.common.exception.walker.TaskException;
import de.fhdw.wtf.common.task.TaskExecutor;
import de.fhdw.wtf.walker.walker.SimpleWalkerTask;

public class CovarianceInExceptionInheritanceChecker extends SimpleWalkerTask {
	
	public CovarianceInExceptionInheritanceChecker(final Model m, final TaskExecutor taskmanager) {
		super(m, taskmanager);
		this.helper = new ExceptionInhHelper();
		// TODO Auto-generated constructor stub
	}
	
	ExceptionInhHelper helper;
	
	@Override
	public void handleClass(final ClassType c) throws TaskException {
		// Nothing to do here!
		
	}
	
	@Override
	public void handleGroup(final Group g) throws TaskException {
		// Nothing to do here!
		
	}
	
	@Override
	public void handleAttribute(final Attribute a, final ClassType owner) throws TaskException {
		// Nothing to do here!
		
	}
	
	@Override
	public void handleConstructorOrOperation(final ConstructorOrOperation coo, final ClassType owner)
			throws TaskException {
		coo.accept(new ConstructorOrOperationExceptionVisitor<TaskException>() {
			
			@Override
			public void handleOperation(final Operation operation) throws TaskException {
				
				operation.getReturnType().accept(new TypeVisitor() {
					
					@Override
					public void handle(final TypeProxy typeProxy) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public void handle(final CompositeType compositeType) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public void handle(final AtomicType atomicType) {
						// TODO Auto-generated method stub
						
					}
				});
				
			}
			
			@Override
			public void handleConstructor(final Constructor constructor) throws TaskException {
				// TODO Auto-generated method stub
				
			}
		});
	}
	
	@Override
	public void finalizeTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void beginTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
}

/*
 * This Class is a Helper. It Contains a Map of all Classes with their Functions and their Exceptions.
 */
class ExceptionInhHelper {
	
}

/**
 * @author Dumann This Class is a Helper for the Covariance-Check... It Contains a List of Types with all Constructors
 *         or Operations in the Helper Format...
 */
class TypeHelper {
	HashMap<Type, CooHelper> map;
}

/**
 * @author Dumann
 *
 */
class CooHelper {
	HashMap<ConstructorOrOperation, Set<ThrownType>> map;
}
