package de.fhdw.wtf.walker.tasks;

import de.fhdw.wtf.common.ast.Model;
import de.fhdw.wtf.common.ast.Operation;
import de.fhdw.wtf.common.ast.type.AtomicType;
import de.fhdw.wtf.common.ast.type.BaseType;
import de.fhdw.wtf.common.ast.type.ClassType;
import de.fhdw.wtf.common.ast.type.CompositeType;
import de.fhdw.wtf.common.ast.type.Type;
import de.fhdw.wtf.common.ast.type.TypeProxy;
import de.fhdw.wtf.common.ast.visitor.AtomicTypeVisitor;
import de.fhdw.wtf.common.ast.visitor.TypeVisitor;
import de.fhdw.wtf.common.exception.walker.TaskException;
import de.fhdw.wtf.common.task.TaskExecutor;
import de.fhdw.wtf.walker.walker.SimpleWalkerTaskForTypes;

public class FillOverrideOperationWalker extends SimpleWalkerTaskForTypes {
	
	public FillOverrideOperationWalker(final Model m, final TaskExecutor taskmanager) {
		super(m, taskmanager);
		// TODO Auto-generated constructor stub
	}
	
	@Override
	public void handleType(final Type c) throws TaskException {
		final java.util.Iterator<Type> TypeIterator = c.getSuperTypes().iterator();
		while (TypeIterator.hasNext()) {
			final Type currentType = TypeIterator.next();
			currentType.accept(new TypeVisitor() {
				
				@Override
				public void handle(final TypeProxy typeProxy) {
					// nothing to do here
					
				}
				
				@Override
				public void handle(final CompositeType compositeType) {
					// nothing ToDo here!
					
				}
				
				@Override
				public void handle(final AtomicType atomicType) {
					atomicType.accept(new AtomicTypeVisitor() {
						
						@Override
						public void handle(final ClassType clazz) {
							final java.util.Iterator<Operation> operationIterator = clazz.getOperations().iterator();
							while (operationIterator.hasNext()) {
								final Operation currentOperation = operationIterator.next();
								final java.util.Iterator<Type> currentOperationSuperClassIterator =
										currentOperation.getContainingType().getSuperTypes().iterator();
								final Type currentSuperType = currentOperationSuperClassIterator.next();
								
								currentSuperType.accept(new TypeVisitor() {
									
									@Override
									public void handle(final TypeProxy typeProxy) {
										// nothing to do here!
										
									}
									
									@Override
									public void handle(final CompositeType compositeType) {
										// nothing to do here!
										
									}
									
									@Override
									public void handle(final AtomicType atomicType1) {
										atomicType1.accept(new AtomicTypeVisitor() {
											
											@Override
											public void handle(final ClassType clazz1) {
												final java.util.Iterator<Operation> operationsInSuperTypeIterator =
														clazz1.getOperations().iterator();
												
												final Operation currentOverrideOperation =
														operationsInSuperTypeIterator.next();
												
												if (currentOverrideOperation.getSignature().equals(
														currentOperation.getSignature())) {
													currentOperation.getOverridingOperations().add(
															currentOverrideOperation);
												}
												
											}
											
											@Override
											public void handle(final BaseType baseType) {
												// nothing to do here!
												
											}
										});
										
									}
								});
							}
							
						}
						
						@Override
						public void handle(final BaseType baseType) {
							// nothing to do here!
							
						}
					});
					
				}
			});
		}
	}
	
	@Override
	public void finalizeTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void beginTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
}
